<?php

$template = <<<END
<h3>Configuration Settings</h3>
These are the primary game settings that control various global aspects of your game.<br /><br />
<form action="index.php?do=control" method="post">
<table cellspacing="0" cellpadding="5" width="98%">
<tr><td width="25%">Game Name</td><td><input type="text" name="gamename" size="20" maxlength="50" value="{{gamename}}" /><br /><span class="grey">The name of your game. Used in page titles and when sending email to new users.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Game is Open?</td><td class="td_alt"><input type="checkbox" name="gameopen" value="1" {{check_gameopen}} /> Yes<br /><span class="grey">Should normally be left on, but you should turn off your game while performing any updates.</span><br /><br /></td></tr>
<tr><td width="25%">Game Path</td><td><input type="text" name="gamepath" size="40" maxlength="200" value="{{gamepath}}" /><br /><span class="grey">The full server path to your game. If you don't know this, please ask your host for assistance.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Game URL</td><td class="td_alt"><input type="text" name="gameurl" size="40" maxlength="200" value="{{gameurl}}" /><br /><span class="grey">The full URL to your game.</span><br /><br /></td></tr>
<tr><td width="25%">Forum URL</td><td><input type="text" name="forumurl" size="40" maxlength="200" value="{{forumurl}}" /><br /><span class="grey">If you have a support forum for your game, enter its URL here - otherwise leave blank to disable this link.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Avatar Path</td><td class="td_alt"><input type="text" name="avatarpath" size="40" maxlength="200" value="{{avatarpath}}" /><br /><span class="grey">The full server path to your avatar uploads folder.</span><br /><br /></td></tr>
<tr><td width="25%">Avatar URL</td><td><input type="text" name="avatarurl" size="40" maxlength="200" value="{{avatarurl}}" /><br /><span class="grey">The full URL to your avatar uploads folder.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Avatar Max Filesize</td><td class="td_alt"><input type="text" name="avatarmaxsize" size="10" maxlength="10" value="{{avatarmaxsize}}" /><br /><span class="grey">Enter the maximum file size (in bytes) for uploaded avatars.<br />Range: 0 to 4294967295.</span><br /><br /></td></tr>
<tr><td width="25%">Show Babblebox?</td><td><input type="checkbox" name="showshout" value="1" {{check_showshout}} /> Yes<br /><span class="grey">Enables the Babblebox iframe in the right panel.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Show Who's Online?</td><td class="td_alt"><input type="checkbox" name="showonline" value="1" {{check_showonline}} /> Yes<br /><span class="grey">Enables the Who's Online listing in the right panel.</span><br /><br /></td></tr>
<tr><td width="25%">Show Item Images?</td><td><select name="showitemimages">{{select_showitemimages}}</select><br /><span class="grey"><b>Slot</b> images use one image for all items in a given slot (e.g. weapons, shields, armor, etc.). <b>ID</b> images use an individual image for every item, based on the item's ID number.<br /><b>Only enable ID images if your /images/items/ folder contains an image for every item in the database, or else you'll get a lot of broken image tags.</b></span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Show Monster Images?</td><td class="td_alt"><input type="checkbox" name="showmonsterimages" value="1" {{check_showmonsterimages}} /> Yes<br /><span class="grey"><b>Only enable monster images if your /images/monsters/ folder contains an image for every monster in the database, or else you'll get a lot of broken image tags.</b></span><br /><br /></td></tr>
<tr><td width="25%">Admin's Email</td><td><input type="text" name="adminemail" size="20" maxlength="200" value="{{adminemail}}" /><br /><span class="grey">This is the game owner's email address, used when sending email to new users.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Enable Email Functions?</td><td class="td_alt"><input type="checkbox" name="verifyemail" value="1" {{check_verifyemail}} /> Yes<br /><span class="grey">Sends a verification letter to anyone who registers an account, to enforce valid email addresses. Also allows users to request new passwords if they lose/forget theirs.<br /><b>NOTE:</b> Some Windows servers may have issues if their php.ini settings are improperly configured. If you're on a Windows host and get a lot of email sending errors, disable this setting or contact your host for more information.</b></span><br /><br /></td></tr>
<tr><td width="25%">Enable ZLib Compression?</td><td><input type="checkbox" name="compression" value="1" {{check_compression}} /> Yes<br /><span class="grey">Enables ZLib output compression, which reduces bandwidth and speeds up page access time for end-users.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Enable Debug Info?</td><td class="td_alt"><input type="checkbox" name="debug" value="1" {{check_debug}} /> Yes<br /><span class="grey">Displays extra information (query count & page generation time) in the footer, and displays full MySQL query errors if they occur.</span><br /><br /></td></tr>
<tr><td width="25%">Bot Check</td><td><input type="text" name="botcheck" size="10" maxlength="10" value="{{botcheck}}" /><br /><span class="grey">Bot Check ensures that players are human by displaying a CAPTCHA challenge form every so often (random 1 in <i>n</i> chance) during exploring. Higher numbers show the Bot Check less often, but may not be as secure. Lower numbers will show the bot check more often, but may annoy some users. Enter 0 to disable the bot check completely.<br />Range: 0 to 4294967295.<br />Recommended: 255.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">PVP Refresh Time</td><td class="td_alt"><input type="text" name="pvprefresh" size="10" maxlength="10" value="{{pvprefresh}}" /><br /><span class="grey">The amount of time (in seconds) the mini PVP frame should wait before refreshing itself to check for new data. Low numbers may cause strain on your server if you have a lot of concurrent users.<br />Range: 0 to 4294967295.</span><br /><br /></td></tr>
<tr><td width="25%">PVP Timeout Limit</td><td><input type="text" name="pvptimeout" size="10" maxlength="10" value="{{pvptimeout}}" /><br /><span class="grey">The amount of time (in seconds) it takes for someone to remain inactive and cause the PVP battle to close.<br />Range: 0 to 4294967295.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Guild Startup Cost</td><td class="td_alt"><input type="text" name="guildstartup" size="10" maxlength="10" value="{{guildstartup}}" /><br /><span class="grey">The amount of gold it takes for a player to start their own Guild.<br />Range: 0 to 4294967295.</span><br /><br /></td></tr>
<tr><td width="25%">Guild Start Level</td><td><input type="text" name="guildstartlvl" size="10" maxlength="10" value="{{guildstartlvl}}" /><br /><span class="grey">The minimum level a player must reach before being allowed to start a Guild.<br />Range: 0 to 4294967295.</span><br /><br /></td></tr>
<tr><td width="25%" class="td_alt">Guild Join Level</td><td class="td_alt"><input type="text" name="guildjoinlvl" size="10" maxlength="10" value="{{guildjoinlvl}}" /><br /><span class="grey">The minimum level a player must reach before being allowed to join a Guild.<br />Range: 0 to 4294967295.</span><br /><br /></td></tr>
<tr><td width="25%">Guild Update Time</td><td><input type="text" name="guildupdate" size="10" maxlength="10" value="{{guildupdate}}" /><br /><span class="grey">The amount of time (in hours) before automatically recalculating Guild Honor Points.<br />Range: 0 to 4294967295.</span><br /><br /></td></tr>
<tr><td colspan="2" style="border-top: solid 2px black;"><center>
<button type="submit" name="submit"><img src="icons/tick.png" align="top" /> Save</button> <button type="reset"><img src="icons/cross.png" align="top" /> Reset</button>
</center></td></tr>
</table>
END;

?>